<?php

namespace Drupal\exchange_rates\Plugin\Block;

use Drupal\Core\Block\BlockBase;

/**
 * Provides a 'ExchangeRatesBlock' block.
 *
 * @Block(
 *  id = "exchange_rates_block",
 *  admin_label = @Translation("Exchange Rates"),
 * )
 */
class ExchangeRatesBlock extends BlockBase
{

  /**
   * Build block
   */
  public function build()
  {
    $config = \Drupal::config('exchange_rates.settings');
    $base_currency = $config->get('base_currency');
    $conversion_currencies = $config->get('conversion_currency');

    // API call to exchangeratesapi.io to fetch exchange rates for base currency
    $client = \Drupal::httpClient();
    $response = json_decode($client->get('https://api.exchangeratesapi.io/latest?base=' . $base_currency)->getBody());
    $rates = [];

    if (!empty($response) && !empty($response->rates)) {
      $rates = $response->rates;
    }

    // Store conversion currency rates in state
    foreach ($rates as $conversion_currency => $rate) {
      if (in_array($conversion_currency, $conversion_currencies)) {
        \Drupal::state()->set('exchange_rates.' . $base_currency . '-' . $conversion_currency, $rate);
      }
    }

    return \Drupal::formBuilder()->getForm('Drupal\exchange_rates\Form\ExchangeRatesBlockForm');
  }
}
